#include <Arduino_FreeRTOS.h>  //فراخوانی کتاب خانه ها
//توابع task و تعریف آن ها
void relay1( void *pvParameters );
void relay2( void *pvParameters );
void gsm( void *pvParameters );
int on1 = 1000, off1 = 1000; //متغیر برای خواندن حداکثر و کحداقل دمای تنظیم شده از سوی کاربر
int on = 1000, off = 1000;
String data = "";  //متغیر جهت خواندن پیامک
void setup()
{
  Serial.begin(115200); //تنظیم باودریت ریت
  Serial.print("AT\r\n");
  delay(500);
  check_connect();  //کنترل اتصال به شبکه GSM
  Serial.print("AT+CMGF=1\r\n");   //به کمک این دستور ارسال پیامک در حالت متن قرار می گیرد.
  delay(1000);
  Serial.print("AT+CMGD=1,4\r\n");    //به کمک این دستور حافظه پیامک ها را خالی می کنیم.
  delay(1000);
  Serial.print("AT+CSMP=17,167,0,0\r\n");   //به کمک این دستور تنظیمات ارسال پیامک را انجام می دهیم. این دستور برای سیم کارت ایرانسل الزامی است.
  delay(1000);
  Serial.print("ATE0\r\n");  //فعا سازی مد اکو ماژول سیم کارت
  delay(700);
  xTaskCreate(    //توجه: به کمک تابع xtaskCreate توابعی که سیستم عامل باید به صورت همزمان اجرا کند، به سیستم عامل معرفی می شود.
    relay   //نام تابع
    ,  "relay"   // یک نام دلخواه جهت اختصاص دادن به تابع
    ,  128  // // میزان حافظه به بایت که تابع نیاز دارد
    ,  NULL //در صورتیکه تابع ورودی داشته باشد در این قسمت درج می شود اما از آنجاییکه ورودی ندارد NULL تعیین می گردد.
    ,  2 // //تععین شماره اولویت اجرا، در سیستم عامل FreeRTOS توابع یا Task ها از لحاظ اولیت اجرا بین 0 الی 3 شماره گذاری می شوند. هرچه عدد بیشتر شود اولویت بالاتر خواهد بود.
    ,  NULL  ); //در صورتیکه handler تعریف شده باشد، در این جا آدرس تابع handler مشخص می شود. تابع handler تابعی خارج از تابع Task بوده که به اجرای آن در مواقع خاص کمک می کند. چون در

  xTaskCreate(
    relay2
    ,  "relay2"
    ,  128
    ,  NULL
    ,  2
    ,  NULL );
  xTaskCreate(
    gsm
    ,  "gsm"
    ,  128
    ,  NULL
    ,  2
    ,  NULL );
}
void loop()
{

}

//******************************************************************************************************
void check_connect() {
  char ccalr[] = {"+CCALR: 1"};
  Serial.println("WAITING TO CONNECT TO NETWORK");
  Serial.flush();
  while (true) {
    Serial.print("AT+CCALR?\r\n"); // ارسال دستور AT+CCALR به ماژول، در صورتیکه ماژول به شبکه متصل گردد ماژول عبارت CCALR: 1 را بر میگرداند
    if (Serial.find(ccalr) == true) // نتیجه تابع find در صورتی true می شود که عبارت مورد نظر یافت شده باشد، در غیر اینصورت درون حلقه تا زمانیکه نتیجه مورد نظر یافت نشود، باقی خواهد ماند
      break; // خروج از حلقه با یافتن پیام مورد نظر
  }
  Serial.println("CONNECTED TO NETWORK");
  Serial.flush();
}
//******************************************************************************************************
void get_sms() {
  unsigned long tm = 0;
  char cmti[] = {"+CMTI"};   //زمانیکه پیامکی دریافت شود، ماژول عبارت CMTI را بر می گرداند.
  if (Serial.find(cmti) == true ) { //به کمک تابع find می توانیم به دنبال عبارت CMTI باشیم این تابع هر گاه این عبارت را در بافر سریال یافت نماید، خروجی آن برابر true می شود.
    if (Serial.available() > 0)     //پاک کردن بافر سریال از داده های احتمالی پیشین
      Serial.readString();
    tm = millis();
    Serial.print("AT+CMGR=1\r\n");   //به کمک این دستور می توانیم پیام ها را از حافظه سیم کارت بخوانیم. عبارت 1به معنای خواندن پیام از حافظه شماره 1 است.
    //  vTaskDelay(5000 / portTICK_PERIOD_MS);
    while (Serial.available() == 0 &&  ((millis() - tm > 7000))) {
      vTaskDelay(10 / portTICK_PERIOD_MS);

    } // منتظر می مانیم تا داده ای دریافت شود و بافر پر شود

    data = Serial.readString(); // خواندن داده های موجود در بافر به صورت رشته
    // data = data.substring(data.indexOf("!") + 1, data.indexOf("#"));   //فرمت ارسال زمان از سوی کاربر بدین صورت است که زمان و تاریخ بین یک علامت تعجب و یک هشتگ قرار می گیرد. /// به کمک تابع index موقعیت کاراکتر علامت تعجب و هشتگ تعیین می شود. تابع substring نیز دو ورودی به عنوان شروع و پایان گرفته و رشتهdata را //با شروع از موقعیت کاراکتر علامت تعجب تا موقعیت علامت هشتگ، در خروجی خود قرار می دهد. این خروجی را ما مجددا در رشته data قرار می دهیم.
    Serial.print("AT+CMGD=1,4\r\n");  //پاک کردن کلیه پیامک ها از حافظه، در این برنامه پس از دریافت پیامک و پردازش رشته ای، حافظه سیم کارت را از کلیه پیام ها پاک می کنیم. بنابراین هموارهبا دریافت پیامک
    //متن پیام در خانه شماره 1 سیم کارت ذخیره می گردد.
  }
}

//******************************************************************************************************
void send_sms() {
  if (Serial.available() > 0)
    Serial.readString();
  vTaskDelay(100 / portTICK_PERIOD_MS);
  Serial.print("AT+CMGS=\"+989****************\"\r\n");  //به جای ستاره ها شماره کاربر گیرنده پیام را وارد کنید.
  delay(1500);
  Serial.println("RELAYS SET!");
  delay(1000);
  Serial.write(0x1a);  //کااراکتر CTRL+Z جهت ارسال پیامک
  delay(1000);
  Serial.print("AT+CMGD=1,4\r\n");  //پاک کردن حافظه از پیام های قبلی
  delay(1000);
}
//******************************************************************************************************

void relay(void *pvParameters)  //تابع رله
{
  (void) pvParameters;

  // پایه شماره 3 به عنوان اتصال به رله تعیین شده که شما می توانید مدت زمان خاموش و روشن بودن آن را تعیین کنید.
  pinMode(6, OUTPUT);

  for (;;) //یک تسک همانند تابع void loop دائما اجرا می شود.
  {
      digitalWrite(6, HIGH);   // فعال شدن خروجی پایه شماره 13 که LED داخلی آردوینو نیز به آن متصل هم هست
      vTaskDelay( on / portTICK_PERIOD_MS ); // روشن ماندن به مدت زمان on که از سوی کاربرد تعیین شده
      digitalWrite(6, LOW);
      vTaskDelay( off / portTICK_PERIOD_MS ); // خاموش ماندن برای مدت زمان تعیین شده توسط کاربر
    
  }
}
//******************************************************************************************************

void relay2(void *pvParameters)  // تابع کنترل دما
{
  (void) pvParameters;
  pinMode(9, OUTPUT);  //پایه رله دوم
  for (;;)
  {
    digitalWrite(9, HIGH);   // فعال شدن خروجی پایه شماره 13 که LED داخلی آردوینو نیز به آن متصل هم هست
    vTaskDelay( on1 / portTICK_PERIOD_MS ); // روشن ماندن به مدت زمان on که از سوی کاربرد تعیین شده
    digitalWrite(9, LOW);
    vTaskDelay( off1 / portTICK_PERIOD_MS ); // خاموش ماندن برای مدت زمان تعیین شده توسط کاربر

  }
}
//******************************************************************************************************

void gsm(void *pvParameters)  // تابع دریافت تنظیمات از طریق پیامک
{
  (void) pvParameters;
  delay(500);
  for (;;)
  {
    //مطابق فرمت، دستور در فرمت {} برای رله دوم و در فرمت <> برای رله اول است.
    get_sms();
    Serial.println("data: ");
    Serial.flush();
    Serial.println(data);
    vTaskDelay(100 / portTICK_PERIOD_MS);
    if (data.indexOf("{") >= 0 && data.indexOf("}") > 0) {  //خواندن و جدا سازی دما
      data = (data.substring(data.indexOf("{") + 1, data.indexOf("}")));
      on1 = data.substring(0, data.indexOf(",")).toInt();
      off1 = data.substring(data.indexOf(",") + 1).toInt();
      Serial.println(on1);
      Serial.println(off1);
    }
    else if (data.indexOf("<") >= 0 && data.indexOf(">") > 0) {   //خواندن مدت زمان فعال ماندن رله
      data = (data.substring(data.indexOf("<") + 1, data.indexOf(">")));
      on = data.substring(0, data.indexOf(",")).toInt();
      off = data.substring(data.indexOf(",") + 1).toInt();
      Serial.println(on);
      Serial.println(off);
    }
  }
}
